/**
 **	File ......... NewThreadForm.cpp
 **	Published ....  2004-07-09
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//#include <stdio.h>

#include "IWeb.h"
#include <libibank.h>
#include "NewThreadForm.h"




NewThreadForm::NewThreadForm(Web *w) : BaseForm(w, "NewThreadForm")
,m_bImageMissing(false)
{
}


NewThreadForm::~NewThreadForm()
{
}


void NewThreadForm::Process()
{
	IWeb *pWeb = static_cast<IWeb *>(GetWeb());
	Database& db = pWeb -> GetDatabase();
	char action[200];

	// <input type="submit" name="NewThreadForm" value="action" ...
	if (GetForm() -> getvalue( (char *)GetFormName().c_str(), action, 200) && *action)
	{
		m_title = GetForm() -> getvalue("title");
		m_body = GetForm() -> getvalue("message");
		long image_num = 0;
		char fn[1000];

		GetForm() -> getvalue("the_file",fn,255);
		m_filename = fn;
		if (!strncmp(fn,"/tmp/",5) && strlen(fn) > 5)
		{
			image_num = AddImage(pWeb -> GetUsernum(), fn);
		}
		if (!image_num)
		{
			m_bImageMissing = true;
			return;
		}
		db::Forum forum(db,pWeb -> GetForum());
		forum.updated = GetDate();
		forum.updated_by = pWeb -> GetUsernum();
		forum.save();
		db::Thread thread(&db);
		thread.started_by = pWeb -> GetUsernum();
		thread.started = GetDate();
		thread.image = image_num;
		thread.forum = pWeb -> GetForum();
		thread.title = m_title;
		thread.updated = GetDate();
		thread.updated_by = pWeb -> GetUsernum();
		thread.save();
		db::Message message(&db);
		message.thread = thread.num;
		message.posted_by = pWeb -> GetUsernum();
		message.posted = GetDate();
		message.title = m_title;
		message.body = m_body;
		message.version = 1;
		message.updated = GetDate();
		message.save();
		db::Linkmessageimage x(&db);
		x.message = message.num;
		x.image = image_num;
		x.save();
		pWeb -> SetThread( thread.num );
		pWeb -> SetPage( 5 ); // View Thread
	}
}


void NewThreadForm::Display(long)
{
	IWeb *pWeb = static_cast<IWeb *>(GetWeb());

//	printf("<h3>New thread</h3>");
	Navigator(pWeb -> GetForum(),-1);
	printf("</td><td align=right>");
//	printf("<div align=right>");
	printf("[ <a href=\"%s?page=2\">settings</a> ",GetCgiName().c_str());
	printf("| <a href=\"%s?logout=1\">logout</a> ",GetCgiName().c_str());
//	printf("]</div>");
	printf("]</td></tr></table>");
	printf("</div>");

	if (m_bImageMissing)
	{
		if (m_filename.size())
			printf("<font class=error size=\"+2\">Image upload failed</font><br>");
		else
			printf("<font class=error size=\"+2\">Image missing</font><br>");
	}
	printf("<form action=\"%s\" method=post enctype=\"multipart/form-data\">",
		GetCgiName().c_str());
	printf("Picture<br>");
	printf("<input type=file name=the_file><br>");
	printf("Title<br>");
	printf("<input type=text name=title size=40 value=\"%s\"><br>",m_title.c_str());
	printf("Message<br>");
	printf("<textarea name=message rows=10 cols=80>%s</textarea><br>",m_body.c_str());
	printf("<input type=submit name=\"%s\" value=\" Create topic \">",GetFormName().c_str());
	printf("</form>");
}


