/**
 **	File ......... NewMessageForm.cpp
 **	Published ....  2004-07-09
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//#include <stdio.h>

#include "IWeb.h"
#include "NewMessageForm.h"




NewMessageForm::NewMessageForm(Web *w) : BaseForm(w, "NewMessageForm")
{
}


NewMessageForm::~NewMessageForm()
{
}


void NewMessageForm::Process()
{
	IWeb *pWeb = static_cast<IWeb *>(GetWeb());
	Database& db = pWeb -> GetDatabase();
	char action[200];

	// <input type="submit" name="NewMessageForm" value="action" ...
	if (GetForm() -> getvalue( (char *)GetFormName().c_str(), action, 200) && *action)
	{
		std::string title = GetForm() -> getvalue("title");
		std::string message_body = GetForm() -> getvalue("message");
		long image_num = 0;
		char fn[1000];

		GetForm() -> getvalue("the_file",fn,255);
		if (!strncmp(fn,"/tmp/",5) && strlen(fn) > 5)
		{
			image_num = AddImage(pWeb -> GetUsernum(), fn);
		}
		db::Forum forum(db,pWeb -> GetForum());
		forum.updated = GetDate();
		forum.updated_by = pWeb -> GetUsernum();
		forum.save();
		db::Thread thread(db,pWeb -> GetThread());
		thread.updated = GetDate();
		thread.updated_by = pWeb -> GetUsernum();
		thread.save();
		db::Message message(&db);
		message.thread = pWeb -> GetThread();
		message.posted_by = pWeb -> GetUsernum();
		message.posted = GetDate();
		message.title = title;
		message.body = message_body;
		message.version = 1;
		message.updated = GetDate();
		message.save();
		if (image_num > 0)
		{
			db::Linkmessageimage x(&db);
			x.message = message.num;
			x.image = image_num;
			x.save();
		}
		pWeb -> SetPage( 5 ); // View Thread
	}
}


void NewMessageForm::Display(long)
{
	IWeb *pWeb = static_cast<IWeb *>(GetWeb());

//	printf("<h3>Post message</h3>");
	Navigator(pWeb -> GetForum(),pWeb -> GetThread(),-1);
	printf("</td><td align=right>");
//	printf("<div align=right>");
	printf("[ <a href=\"%s?page=2\">settings</a> ",GetCgiName().c_str());
	printf("| <a href=\"%s?logout=1\">logout</a> ",GetCgiName().c_str());
//	printf("]</div>");
	printf("]</td></tr></table>");
	printf("</div>");

	printf("<form action=\"%s\" method=post enctype=\"multipart/form-data\">",
		GetCgiName().c_str());
	printf("Picture (optional)<br>");
	printf("<input type=file name=the_file><br>");
	printf("Title<br>");
	printf("<input type=text name=title size=40><br>");
	printf("Message<br>");
	printf("<textarea name=message rows=10 cols=80></textarea><br>");
	printf("<input type=submit name=\"%s\" value=\" Post \">",GetFormName().c_str());
	printf("</form>");
}


